//--------------------------------------------------------------------------------------------------
//
// Title       : VGA_DATA
// Design      : VGA
// Author      : 0
// Company     : 0
//
//-------------------------------------------------------------------------------------------------
//
// File        : VGA_DATA.v
// Generated   : Mon Jan  5 14:32:02 2004
// From        : interface description file
// By          : Itf2Vhdl ver. 1.20
//
//-------------------------------------------------------------------------------------------------
//
// Description : 
//
//-------------------------------------------------------------------------------------------------
`timescale 1ps / 1ps

`define SCREEN_SIZE_X 512
`define SCREEN_SIZE_Y 450

`define BALL_WIDTH 10
`define BALL_HEIGHT 10

`define PADDLE_TOP 375
`define PADDLE_BOTTOM 380
`define PADDLE_WIDTH 50

`define LIFE1_TOP 385
`define LIFE1_BOTTOM 395
`define LIFE1_LEFT 485
`define LIFE1_RIGHT 495

`define LIFE2_TOP 385
`define LIFE2_BOTTOM 395
`define LIFE2_LEFT 470
`define LIFE2_RIGHT 480

`define LIFE3_TOP 385
`define LIFE3_BOTTOM 395
`define LIFE3_LEFT 455
`define LIFE3_RIGHT 465

module VGA_DATA (clk, reset, data, csb, oeb, web, en, hcnt, vcnt, v_syncb, ball_x, ball_y, paddle_x, rgb, life);
	
	input clk ;
	input reset;
	
	input [7:0] data ;
//	output [14:0] addr;
	output csb ;
	output oeb ;
	output web ;
	
	output en;
	
	input [9:0] hcnt ;
	input [9:0] vcnt ;
	input v_syncb;
	
	input [10:0] ball_x;
	input [10:0] ball_y;
	input [10:0] paddle_x;
	
	output [2:0] rgb ;		
        input [1:0] life;
	
	wire clk ;
	wire [7:0] data ;
	wire [9:0] hcnt ;
	wire reset ;
	wire [9:0] vcnt ;
	wire v_syncb;
	
	
//	reg [14:0] addr ;
	wire csb ;
	wire web ;	
	wire oeb ;
	wire en ;	
	reg [2:0] rgb ;
        wire [1:0] life;
	
	reg [10:0] ball_left;
	reg [10:0] ball_right;
	reg [10:0] ball_top;
	reg [10:0] ball_bottom;
	
	reg [10:0] paddle_left;
	reg [10:0] paddle_right;
	
	wire en_ball;
	wire en_paddle;
	wire en_life1;
	wire en_life2;
	wire en_life3;
	wire en_block;
	wire en_line;
	
	assign csb = 0;
	assign web = (v_syncb);
	assign oeb = 0;
	
	//Calculate position of ball and paddle
	always @(posedge v_syncb) begin
			ball_left <= ball_x-`BALL_WIDTH/2;
			ball_right <= ball_x+`BALL_WIDTH/2;
			ball_top <= ball_y-`BALL_HEIGHT/2;
			ball_bottom <= ball_y+`BALL_HEIGHT/2;
			
			paddle_left <= paddle_x-`PADDLE_WIDTH/2;
			paddle_right <= paddle_x+`PADDLE_WIDTH/2;
		end
	
/*	always @(v_syncb) begin
			addr[14:0] <= {5'b00000,vcnt[8:4],hcnt[9:5]};	
		end*/
	
	assign en_ball = (hcnt > ball_left)&(hcnt < ball_right)&(vcnt > ball_top)&(vcnt < ball_bottom)&
          (!((hcnt == ball_left + 1) && (vcnt == ball_top + 1))) &
          (!((hcnt == ball_left + 2) && (vcnt == ball_top + 1))) &
          (!((hcnt == ball_left + 1) && (vcnt == ball_top + 2))) &
          (!((hcnt == ball_right - 1) && (vcnt == ball_top + 1))) &
          (!((hcnt == ball_right - 2) && (vcnt == ball_top + 1))) &
          (!((hcnt == ball_right - 1) && (vcnt == ball_top + 2))) &
          (!((hcnt == ball_left + 1) && (vcnt == ball_bottom - 1))) &
          (!((hcnt == ball_left + 2) && (vcnt == ball_bottom - 1))) &
          (!((hcnt == ball_left + 1) && (vcnt == ball_bottom - 2))) &
          (!((hcnt == ball_right - 1) && (vcnt == ball_bottom - 1))) &
          (!((hcnt == ball_right - 2) && (vcnt == ball_bottom - 1))) &
          (!((hcnt == ball_right - 1) && (vcnt == ball_bottom - 2)));
	assign en_paddle = (hcnt > paddle_left)&(hcnt < paddle_right)&(vcnt > `PADDLE_TOP)&(vcnt < `PADDLE_BOTTOM);
	assign en_life1 = (hcnt > `LIFE1_LEFT)&(hcnt < `LIFE1_RIGHT)&(vcnt > `LIFE1_TOP)&(vcnt < `LIFE1_BOTTOM)&(life >= 1);
	assign en_life2 = (hcnt > `LIFE2_LEFT)&(hcnt < `LIFE2_RIGHT)&(vcnt > `LIFE2_TOP)&(vcnt < `LIFE2_BOTTOM)&(life >= 2);
	assign en_life3 = (hcnt > `LIFE3_LEFT)&(hcnt < `LIFE3_RIGHT)&(vcnt > `LIFE3_TOP)&(vcnt < `LIFE3_BOTTOM)&(life >= 3);
	assign en_block = (data) && (hcnt < 512) && (vcnt < 128);
	assign en_line = ((hcnt[4:0] == 5'b00000)|(vcnt[3:0] == 4'b0000));

/*        wire [14:0] addr2;
        assign addr2 = {5'b00000,vcnt[8:4],hcnt[9:5]};*/
	
	always @(posedge clk) begin
			
			rgb <= 3'b000; // BG : black
			if(en_block)
				rgb <= data[2:0];
			if(en_line)
				rgb <= 3'b000; // line : black
			if(en_paddle)
				rgb <= 3'b011; // Paddle : Jade
			if(en_ball)
				rgb <= 3'b110; // Ball : Yellow
			if(en_life1)
				rgb <= 3'b010; // Life : Green
			if(en_life2)
				rgb <= 3'b010; // Life : Green
			if(en_life3)
				rgb <= 3'b010; // Life : Green
			
			if((hcnt == 1)||(vcnt == 0)||(hcnt == `SCREEN_SIZE_X-1)||(vcnt == `SCREEN_SIZE_Y-1))
				rgb <= 111; //white
//                addr <= addr2;
		end
endmodule
