
`timescale 1ps / 1ps

module ark (clk, reset, left, right, game, web, csb, oeb, hsyncb, vsyncb, rgb,
  addr, data);

  input clk;
  input reset;
  input left;
  input right;
  input game;

  output web;
  output csb;
  output oeb;
  output hsyncb;
  output vsyncb;
  output [2:0] rgb;
  output [14:0] addr;
  inout [7:0] data;

  wire clk;
  wire reset;
  wire left;
  wire right;
  wire game;

  wire reset_n;
  wire [8:0] x_increment;
  wire start;
  wire data_ack;
  wire read;
  wire err;
  wire [10:0] paddle_x;
  wire [10:0] ball_x;
  wire [10:0] ball_y;
  wire [1:0] life;
  wire [14:0] addr;
  wire [14:0] addr2;
  wire [14:0] addr3;
  wire web;
  wire web1;
  wire web2;
  wire csb;
  wire oeb;
  wire [9:0] hcnt;
  wire [9:0] vcnt;
  wire hsyncb;
  wire vsyncb;
  wire [2:0] rgb;
  tri [7:0] data;
  wire en;
  wire en2;

  assign reset_n = (~reset);
  assign err = (0);
  assign addr = ((vsyncb) ? (addr3) : (addr2));

  test_set1 test_set2 (clk, reset, left, right, game, x_increment, start,
    data_ack, read);
  main_ark main_ark2 (clk, reset_n, x_increment, game, right, data_ack, err,
    vsyncb, read, paddle_x, ball_x, ball_y, life, addr2, web1, data, en2);
  VGA_DISP VGA_DISP2 (clk, reset_n, hcnt, vcnt, hsyncb, vsyncb, en2, addr3);
  VGA_DATA VGA_DATA2 (clk, reset_n, data, csb, oeb, web2, en, hcnt,
    vcnt, vsyncb, ball_x, ball_y, paddle_x, rgb, life);
  or or2 (web, web1, web2);

endmodule
