
`timescale 1ps / 1ps

module ark_mouse (clk, reset, left, right, game, ps2_clk, ps2_data, web, csb,
  oeb, hsyncb, vsyncb, rgb, addr, data, sound);

  input clk;
  input reset;
  input left;
  input right;
  input game;
  input ps2_clk;
  input ps2_data;

  output web;
  output csb;
  output oeb;
  output hsyncb;
  output vsyncb;
  output [2:0] rgb;
  output [14:0] addr;
  inout [7:0] data;
  output sound;

  wire clk;
  wire reset;
  wire left;
  wire right;
  wire game;

  wire reset_n;
  wire [8:0] x_increment;
  wire start;
  wire data_ack;
  wire read;
  wire err;
  wire [10:0] paddle_x;
  wire [10:0] ball_x;
  wire [10:0] ball_y;
  wire [1:0] life;
  wire [14:0] addr;
  wire [14:0] addr2;
  wire [14:0] addr3;
  wire web;
  wire web1;
  wire web2;
  wire csb;
  wire oeb;
  wire [9:0] hcnt;
  wire [9:0] vcnt;
  wire hsyncb;
  wire vsyncb;
  wire [2:0] rgb;
  tri [7:0] data;
  wire en;
  wire en2;
  wire [8:0] y_increment;

  wire left2;
  wire right2;
  wire game2;

  wire left3;
  wire right3;
  wire game3;

  wire [7:0] keycode;

  wire data_ack2;

  wire [2:0] collision;

  wire sound;

  assign left2 = (keycode == 8'h16);
  assign right2 = (keycode == 8'h1e);
  assign game2 = (keycode == 8'h26);

  assign reset_n = (~reset);
  assign addr = ((vsyncb) ? (addr3) : (addr2));

  assign left3 = (left2 | left);
  assign right3 = (right2 | right);
  assign game3 = (game2 | game);

  sound_ark sound_ark2 (clk, reset_n, collision, sound);
  test_set1 test_set2 (clk, reset, left3, right3, game3, x_increment, start,
    data_ack, read);
  ps2_keyboard ps2_keyboard2 (clk, data_ack2, ps2_clk, ps2_data, reset_n, 0,
    keycode, err);
  main_ark main_ark2 (clk, reset_n, x_increment, start, right, data_ack, 0,
    vsyncb, read, paddle_x, ball_x, ball_y, life, addr2, web1, data, en2,
    collision);
  VGA_DISP VGA_DISP2 (clk, reset_n, hcnt, vcnt, hsyncb, vsyncb, en2, addr3);
  VGA_DATA VGA_DATA2 (clk, reset_n, data, csb, oeb, web2, en, hcnt,
    vcnt, vsyncb, ball_x, ball_y, paddle_x, rgb, life);
  or or2 (web, web1, web2);

endmodule
