
`timescale 1ps / 1ps

module sound_ark (clk, reset_n, collision, sound);

  input clk;
  input reset_n;
  input [2:0] collision;
  output sound;

  wire clk;
  wire reset_n;
  wire [2:0] collision;
  reg sound;

  reg [2:0] collision2;

  reg [22:0] sound_timeout_count;
  wire [22:0] sound_timeout_count2;
  reg [15:0] sound_count;
  wire [15:0] sound_count2;

  assign sound_timeout_count2 = ((sound_timeout_count) ?
    (sound_timeout_count + 1) : (0));
  assign sound_count2 = (sound_count + 1);

  always
    @(posedge clk or negedge reset_n) begin
      if (~reset_n) begin
        sound_timeout_count <= 0;
      end
      else begin
        sound_timeout_count <= sound_timeout_count2;
        if (collision[0]) begin
          sound_timeout_count <= 1;
          collision2 <= collision;
        end
      end
    end

  always
    @(posedge clk or negedge reset_n) begin
      if (~reset_n) begin
        sound <= 0;
        sound_count <= 0;
      end
      else begin
        if (sound_timeout_count) begin
          case (collision2[2:1])
            2'b00: begin
              if (!sound_count[15:0]) begin
                sound <= ~sound;
              end
            end
            2'b01: begin
              if (!sound_count[14:0]) begin
                sound <= ~sound;
              end
            end
            2'b10: begin
              if (!sound_count[13:0]) begin
                sound <= ~sound;
              end
            end
            2'b11: begin
              if (!sound_count[12:0]) begin
                sound <= ~sound;
              end
            end
          endcase
          sound_count <= sound_count2;
        end
        else begin
          sound_count <= 0;
        end
      end
    end

endmodule
