module test_set1(clk, reset, left, right, game, x_increment, start, data_ack, read);

input clk;
input reset;
input left;
input right;
input game;
input read;

output [10:0] x_increment;
output start;
output data_ack;

wire clk;
wire reset;
wire left;
wire right;
wire game;
wire read;

wire left_r;
wire right_r;

reg start;
reg [10:0] x_increment;
reg data_ack;

reg [17:0] count_x;

always @(posedge clk) begin
		if (reset) begin
			count_x <= 18'b000000000000000000;
		end
		else begin
			if(left | right) begin
				count_x <= count_x + 1;
			end
		end
end

assign left_r = (count_x == 18'b000000000000000000) & left;
assign right_r = (count_x == 18'b000000000000000000) & right;

always @(posedge clk) begin
	if(reset) begin
		x_increment <= 11'b00000000000;
		data_ack <= 1'b0;	
                start <= 0;
	end
	else begin
		if(read) begin
			data_ack <= 1'b0;
			x_increment <= 11'b00000000000;
                        start  <= 0;
		end
		if(left_r) begin
//			x_increment <= 11'b11111111011;
			x_increment <= 11'b11111111101;
			data_ack <= 1'b1;
                        start  <= 0;
		end
		if(right_r) begin
//			x_increment <= 11'b00000000101;
			x_increment <= 11'b00000000011;
			data_ack <= 1'b1;
                        start  <= 0;
		end
                if(game) begin
                        x_increment <= 0;
                        data_ack <= 1;
                        start  <= 1;
                end
	end 
end

endmodule
